# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FormserviceapicustomresourcetypesMainActions(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'allocate': 'FormserviceapicustomresourcetypesMainActionsAllocate',
        'create': 'FormserviceapicustomresourcetypesMainActionsAllocate',
        'read': 'FormserviceapicustomresourcetypesMainActionsAllocate',
        'update': 'FormserviceapicustomresourcetypesMainActionsAllocate',
        'delete': 'FormserviceapicustomresourcetypesMainActionsAllocate'
    }

    attribute_map = {
        'allocate': 'allocate',
        'create': 'create',
        'read': 'read',
        'update': 'update',
        'delete': 'delete'
    }

    def __init__(self, allocate=None, create=None, read=None, update=None, delete=None):  # noqa: E501
        """FormserviceapicustomresourcetypesMainActions - a model defined in Swagger"""  # noqa: E501
        self._allocate = None
        self._create = None
        self._read = None
        self._update = None
        self._delete = None
        self.discriminator = None
        if allocate is not None:
            self.allocate = allocate
        if create is not None:
            self.create = create
        if read is not None:
            self.read = read
        if update is not None:
            self.update = update
        if delete is not None:
            self.delete = delete

    @property
    def allocate(self):
        """Gets the allocate of this FormserviceapicustomresourcetypesMainActions.  # noqa: E501


        :return: The allocate of this FormserviceapicustomresourcetypesMainActions.  # noqa: E501
        :rtype: FormserviceapicustomresourcetypesMainActionsAllocate
        """
        return self._allocate

    @allocate.setter
    def allocate(self, allocate):
        """Sets the allocate of this FormserviceapicustomresourcetypesMainActions.


        :param allocate: The allocate of this FormserviceapicustomresourcetypesMainActions.  # noqa: E501
        :type: FormserviceapicustomresourcetypesMainActionsAllocate
        """

        self._allocate = allocate

    @property
    def create(self):
        """Gets the create of this FormserviceapicustomresourcetypesMainActions.  # noqa: E501


        :return: The create of this FormserviceapicustomresourcetypesMainActions.  # noqa: E501
        :rtype: FormserviceapicustomresourcetypesMainActionsAllocate
        """
        return self._create

    @create.setter
    def create(self, create):
        """Sets the create of this FormserviceapicustomresourcetypesMainActions.


        :param create: The create of this FormserviceapicustomresourcetypesMainActions.  # noqa: E501
        :type: FormserviceapicustomresourcetypesMainActionsAllocate
        """

        self._create = create

    @property
    def read(self):
        """Gets the read of this FormserviceapicustomresourcetypesMainActions.  # noqa: E501


        :return: The read of this FormserviceapicustomresourcetypesMainActions.  # noqa: E501
        :rtype: FormserviceapicustomresourcetypesMainActionsAllocate
        """
        return self._read

    @read.setter
    def read(self, read):
        """Sets the read of this FormserviceapicustomresourcetypesMainActions.


        :param read: The read of this FormserviceapicustomresourcetypesMainActions.  # noqa: E501
        :type: FormserviceapicustomresourcetypesMainActionsAllocate
        """

        self._read = read

    @property
    def update(self):
        """Gets the update of this FormserviceapicustomresourcetypesMainActions.  # noqa: E501


        :return: The update of this FormserviceapicustomresourcetypesMainActions.  # noqa: E501
        :rtype: FormserviceapicustomresourcetypesMainActionsAllocate
        """
        return self._update

    @update.setter
    def update(self, update):
        """Sets the update of this FormserviceapicustomresourcetypesMainActions.


        :param update: The update of this FormserviceapicustomresourcetypesMainActions.  # noqa: E501
        :type: FormserviceapicustomresourcetypesMainActionsAllocate
        """

        self._update = update

    @property
    def delete(self):
        """Gets the delete of this FormserviceapicustomresourcetypesMainActions.  # noqa: E501


        :return: The delete of this FormserviceapicustomresourcetypesMainActions.  # noqa: E501
        :rtype: FormserviceapicustomresourcetypesMainActionsAllocate
        """
        return self._delete

    @delete.setter
    def delete(self, delete):
        """Sets the delete of this FormserviceapicustomresourcetypesMainActions.


        :param delete: The delete of this FormserviceapicustomresourcetypesMainActions.  # noqa: E501
        :type: FormserviceapicustomresourcetypesMainActionsAllocate
        """

        self._delete = delete

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FormserviceapicustomresourcetypesMainActions, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FormserviceapicustomresourcetypesMainActions):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
